/**********************************************************************/
/**
 * @file MB9BF506_startup.s
 * X^[gAbv
 *
 * @author T.Tanaka
 * $Date: 2013/03/27 $
 * $Revision: $
 *
 * Copyright (c) 2013 Interface Inc. All Rights reserved.
 *
 * <pre>
 * --------------------------------------------------------------------
 * ύX
 *  +-------------- ԍ (000 ` 999)
 *  |	  +--------- CĂVXeo[W
 *  |	  | 	+--- VKAύXAǉA폜̕
 *  v	  v 	v
 *  No  Ver   N	  O			
 * ---+-----+----+----------+-------------+----------------------------
 * 000 01.00 VK 2013/03/27 ITF Tanaka    VK쐬
 * ---+-----+----+----------+-------------+----------------------------
 * </pre>
 */
/**********************************************************************/

/*------------------------------------------*/
/*				錾						*/
/*------------------------------------------*/
		MODULE	?cstartup
		SECTION	CSTACK:DATA:NOROOT(3)

/*------------------------------------------*/
/*				OQ					*/
/*------------------------------------------*/
		EXTERN	__iar_program_start
		EXTERN	Timer_Interrupt
		EXTERN	hc_interrupt

/*------------------------------------------*/
/*				xN^e[u				*/
/*------------------------------------------*/
		SECTION	.intvec:CODE:ROOT(2)
		PUBLIC	__vector_table
		DATA

__vector_table
		DCD		sfe(CSTACK) 			;  0	Top of Stack
		DCD		__iar_program_start		;  1	Reset Handler
		DCD		Default_Handler			;  2	NMI Handler
		DCD		Default_Handler			;  3	Hard Fault Handler
		DCD		Default_Handler			;  4	MPU Fault Handler
		DCD		Default_Handler			;  5	Bus Fault Handler
		DCD		Default_Handler			;  6	Usage Fault Handler
		DCD		0						;  7	Reserved
		DCD		0						;  8	Reserved
		DCD		0						;  9	Reserved
		DCD		0						; 10	Reserved
		DCD		Default_Handler			; 11	SVCall Handler
		DCD		Default_Handler			; 12	Debug Monitor Handler
		DCD		0						; 13	Reserved
		DCD		Default_Handler			; 14	PendSV Handler
		DCD		Default_Handler			; 15	SysTick Handler
		DCD		Default_Handler			; 16	Anomalous Frequency Detection by Clock Supervisor (FCS)
		DCD		Default_Handler			; 17	Software Watchdog Timer
		DCD		Default_Handler			; 18	Low Voltage Detector (LVD)
		DCD		Default_Handler			; 19	Wave Form Generator unit0, unit1
		DCD		Default_Handler			; 20	External Interrupt Request ch.0 to ch.7
		DCD		Default_Handler			; 21	External Interrupt Request ch.8 to ch.15
		DCD		Timer_Interrupt 		; 22	Dual Timer / Quadrature Decoder Unit unit0, unit1
		DCD		Default_Handler			; 23	Reception Interrupt Request of MFSI0
		DCD		Default_Handler			; 24	Transmission Interrupt Request and Status Interrupt Request of MFSI0
		DCD		Default_Handler			; 25	Reception Interrupt Request of of MFSI1
		DCD		Default_Handler			; 26	Transmission Interrupt Request and Status Interrupt Request of MFSI1
		DCD		Default_Handler			; 27	Reception Interrupt Request of MFSI2
		DCD		Default_Handler			; 28	Transmission Interrupt Request and Status Interrupt Request of MFSI2
		DCD		Default_Handler			; 29	Reception Interrupt Request of MFSI3
		DCD		Default_Handler			; 30	Transmission Interrupt Request and Status Interrupt Request of MFSI3
		DCD		Default_Handler			; 31	Reception Interrupt Request of MFSI4
		DCD		Default_Handler			; 32	Transmission Interrupt Request and Status Interrupt Request of MFSI4
		DCD		Default_Handler			; 33	Reception Interrupt Request of of MFSI5
		DCD		Default_Handler			; 34	Transmission Interrupt Request and Status Interrupt Request of MFSI5
		DCD		Default_Handler			; 35	Reception Interrupt Request of MFSI6
		DCD		Default_Handler			; 36	Transmission Interrupt Request and Status Interrupt Request of MFSI6
		DCD		Default_Handler			; 37	Reception Interrupt Request of MFSI7
		DCD		Default_Handler			; 38	Transmission Interrupt Request and Status Interrupt Request of MFSI7
		DCD		Default_Handler			; 39	PPG unit0, unit1
		DCD		Default_Handler			; 40	External Main OSC/External Sub OSC/Main PLL/PLL for USB/Watch Count
		DCD		Default_Handler			; 41	ADC unit0
		DCD		Default_Handler			; 42	ADC unit1
		DCD		Default_Handler			; 43	ADC unit2
		DCD		Default_Handler			; 44	Free-run Timer unit0, unit1
		DCD		Default_Handler			; 45	Input Capture unit0, unit1
		DCD		Default_Handler			; 46	Output Compare unit0, unit1
		DCD		Default_Handler			; 47	Base Timer ch.0 to ch.7
		DCD		Default_Handler			; 48	CAN ch.0
		DCD		Default_Handler			; 49	CAN ch.1
		DCD		Default_Handler			; 50	USB Function (DRQ of End Point 1 to 5)
		DCD		hc_interrupt			; 51	USB Function (DRQI of End Point 0, DRQO and each status)/USB HOST
		DCD		0						; 52	Reserved
		DCD		0						; 53	Reserved
		DCD		Default_Handler			; 54	DMA Controller (DMAC) ch.0
		DCD		Default_Handler			; 55	DMA Controller (DMAC) ch.1
		DCD		Default_Handler			; 56	DMA Controller (DMAC) ch.2
		DCD		Default_Handler			; 57	DMA Controller (DMAC) ch.3
		DCD		Default_Handler			; 58	DMA Controller (DMAC) ch.4
		DCD		Default_Handler			; 59	DMA Controller (DMAC) ch.5
		DCD		Default_Handler			; 60	DMA Controller (DMAC) ch.6
		DCD		Default_Handler			; 61	DMA Controller (DMAC) ch.7

/**********************************************************************/
/**
 * @brief	ftHg̊荞݃nh
 */
		THUMB
		SECTION	.text:CODE:REORDER:NOROOT(1)

Default_Handler
		B		Default_Handler

/**********************************************************************/
/**
 * @brief	EFCg
 *
 * @param	r0	[in]	EFCg[us]
 */
		PUBLIC	wait_us

wait_us
		LSL		r0, r0, #4		;r0r0~16
wait_loop
		SUBS	r0, r0, #1		;1state
		NOP						;1state
		NOP						;1state
		BNE		wait_loop		;2state
		MOV		pc, lr

		END
