/**********************************************************************/
/**
 * @file MB9BF506_timer2.c
 * ITF-SingleHost Tv^C}W[
 *
 * @author T.Tanaka
 * $Date: 2013/03/27 $
 * $Revision: $
 *
 * Copyright (c) 2013 Interface Inc. All Rights reserved.
 *
 * <pre>
 * --------------------------------------------------------------------
 * ύX
 *  +-------------- ԍ (000 ` 999)
 *  |	  +--------- CĂVXeo[W
 *  |	  | 	+--- VKAύXAǉA폜̕
 *  v	  v 	v
 *  No  Ver   N	  O			
 * ---+-----+----+----------+-------------+----------------------------
 * 000 01.00 VK 2013/03/27 ITF Tanaka    VK쐬
 * ---+-----+----+----------+-------------+----------------------------
 * </pre>
 */
/**********************************************************************/

/*------------------------------------------*/
/*				CN[h				*/
/*------------------------------------------*/
#include "itflib.h"
#include "timer.h"

/*------------------------------------------*/
/*				錾						*/
/*------------------------------------------*/
/**
 * @brief	TimerPre ݒ (0 ` 2)
 */
#define TIMER_PRE			0

/**
 * @brief	1us ɑΉJEg
 */
#define TIMER_COUNT_1us		40

/**
 * @name	^C}WX^`
 * @{
 */
#define TIMER2_LOAD			(*(volatile uint32_t*)0x40015020)
#define TIMER2_VALUE		(*(volatile uint32_t*)0x40015024)
#define TIMER2_CONTROL		(*(volatile uint32_t*)0x40015028)
#define   BIT_ONESHOT			(0x01u)
#define   BIT_TIMER_SIZE		(0x02u)
#define   BIT_TIMER_PRE			(TIMER_PRE << 2)
#define   BIT_INT_ENABLE		(0x20u)
#define   BIT_TIMER_MODE		(0x40u)
#define   BIT_TIMER_EN			(0x80u)
/** @} */

/**********************************************************************/
/**
 * @brief	^C}Jn
 */
void Timer2_Start(void)
{
	TIMER2_CONTROL = BIT_ONESHOT | BIT_TIMER_SIZE | BIT_TIMER_PRE | BIT_TIMER_EN;
	TIMER2_LOAD = 0xFFFFFFFF;
}

/**********************************************************************/
/**
 * @brief	^C}I
 *
 * @return	oߎ (us)
 */
uint32_t Timer2_Stop(void)
{
	uint32_t	value;
	
	value = TIMER2_VALUE;
	TIMER2_CONTROL = BIT_ONESHOT | BIT_TIMER_SIZE | BIT_TIMER_PRE;
	value = (0xFFFFFFFF - value) / TIMER_COUNT_1us;

	return value;
}
