/**********************************************************************/
/**
 * @ingroup ITFLIB
 * @file itfdebug.h
 * ITFLIBCu fobOwb_t@C.
 *
 * @author M.Furuta
 * $Date: 2004/11/16 12:14:02 $
 * $Revision: 1.2 $
 *
 * Copyright (c) 2003-2004 Interface Inc. All Rights reserved.
 * 
 * <pre>
 * --------------------------------------------------------------------
 * ύX
 *  +-------------- ԍ (000 ` 999)
 *  |	  +--------- CĂVXeo[W
 *  |	  | 	+--- VKAύXAǉA폜̕
 *  v	  v 	v
 *  No  Ver   N	  O			
 * ---+-----+----+----------+-------------+----------------------------
 * 000 01.00 VK 2004/02/20 ITF Furuta     VK쐬
 * 001 01.03 ύX 2004/11/12 ITF Takasaki   itftypes𔽉fB
 * ---+-----+----+----------+-------------+----------------------------
 * </pre>
 */
/**********************************************************************/
#ifndef __ITFDEBUG_H__
#define __ITFDEBUG_H__
#ifdef __cplusplus
extern "C" {
#endif

/*------------------------------------------*/
/*				CN[h				*/
/*------------------------------------------*/


/*------------------------------------------*/
/*				錾						*/
/*------------------------------------------*/
#define __ITFDEBUG_STRING_PRINT__
#define __ITFDEBUG_MEMORY_PRINT__
#define __ITFDEBUG_ASSERT__
#define __ITFDEBUG_DUMP__

#define ICRLF										"\r\n"					/**< sR[h */

#define __STR2__(x) #x
#define __STR1__(x) __STR2__(x)
#define __LOC__ __FILE__ "("__STR1__(__LINE__)"):"

/*
	fobOx
*/
#define IDL_TRACE			0x00000001
#define IDL_ERROR			0x00000002
#define IDL_WARNING			0x00000004
#define IDL_INFO			0x00000008
#define IDL_RX				0x00000010
#define IDL_TX				0x00000020
#define IDL_EVENT			0x00000040
#define IDL_IOCTL			0x00000080
#define IDL_CMD				0x00000100
#define IDL_ALL				0xffffffff
#define IDL_DEFAULT			(IDL_ALL)

#define ITFDEBUG_Level		IDL_DEFAULT										/**< fobOx */

/*
	fobOo
*/
#if (defined(__ITFDEBUG__) && (defined(__ITFDEBUG_STRING_PRINT__) || defined(__ITFDEBUG_MEMORY_PRINT__)))
	extern int8_t *ITFDEBUG_Get_Buffer();
#endif


#if (defined(__ITFDEBUG__) && defined(__ITFDEBUG_STRING_PRINT__))


	extern void ITFDEBUG_Put_String(int8_t *str);
	void ITFDEBUG_Put_Binary(uint8_t *bin, int32_t length);


	#define IDP_MAX_STRING_LENGTH					(1024)					/**< őfobOo͕ */
	#define IDP_MAX_TASKS							10						/**< ő^XN */
	#define IDP_DELAY								0						/**< IDP,IDBP̃fBC[b] */
	#define IDP_BUFFER								ITFDEBUG_Get_Buffer()	/**< fobOo͗pobt@ */

 #if !defined(linux)

	#define IDP(level,string)						\
	{												\
		if (ITFDEBUG_Level & (level)) {			\
			ITFDEBUG_Put_String((int8_t *)(string));	\
		}											\
	}
	#define IDP1(level,format,p1)					{sprintf(IDP_BUFFER,format,p1);IDP(level,IDP_BUFFER);}
	#define IDP2(level,format,p1,p2)				{sprintf(IDP_BUFFER,format,p1,p2);IDP(level,IDP_BUFFER);}
	#define IDP3(level,format,p1,p2,p3)				{sprintf(IDP_BUFFER,format,p1,p2,p3);IDP(level,IDP_BUFFER);}
	#define IDP4(level,format,p1,p2,p3,p4)			{sprintf(IDP_BUFFER,format,p1,p2,p3,p4);IDP(level,IDP_BUFFER);}
	#define IDP5(level,format,p1,p2,p3,p4,p5)		{sprintf(IDP_BUFFER,format,p1,p2,p3,p4,p5);IDP(level,IDP_BUFFER);}
	#define IDP6(level,format,p1,p2,p3,p4,p5,p6)	{sprintf(IDP_BUFFER,format,p1,p2,p3,p4,p5,p6);IDP(level,IDP_BUFFER);}
	#define IFLDP()									{sprintf(IDP_BUFFER, __FILE__ "(%d)" ICRLF, __LINE__);IDP(IDP_BUFFER);}
	#define ITRACE(string)							{IDP(IDL_TRACE,string);}
	#define IERR(string)							{IDP(IDL_ERROR,"ERROR>");IDP(IDL_ERROR,string);}
	#define IFLERR()								{sprintf(IDP_BUFFER, ICRLF "ERROR>" __FILE__ "(%d)" ICRLF, __LINE__);IDP(IDL_ERROR,IDP_BUFFER);}
	#define IFLERR1(a)								{sprintf(IDP_BUFFER, ICRLF "ERROR>" __FILE__ "(%d): %d" ICRLF, __LINE__, a);IDP(IDL_ERROR,IDP_BUFFER);}
	#define IWARN(string)							{IDP(IDL_WARNING,"WARNING>");IDP(IDL_WARNING,string);}
	#define IFLWARN()								{sprintf(IDP_BUFFER, ICRLF "WARNING>" __FILE__ "(%d)" ICRLF, __LINE__);IDP(IDL_WARNING,IDP_BUFFER);}
	#define IFLWARN1(a)								{sprintf(IDP_BUFFER, ICRLF "WARNING>" __FILE__ "(%d): %d" ICRLF, __LINE__, a);IDP(IDL_WARNING,IDP_BUFFER);}
	#define IDBP(level,b,l)							\
	{												\
		if (ITFDEBUG_Level & (level)) {				\
			ITFDEBUG_Put_Binary((uint8_t *)(b), (int32_t)(l));	\
		}											\
	}

 #else /* __linux__ */
	#include <stdio.h>

	#define IDP(level, string)						\
	{												\
		if (ITFDEBUG_Level & (level)) {			\
			printf((int8_t *)(string));	\
		}											\
	}
	#define IDP1(level, format, p1)					{printf(__LOC__); printf(format, p1);}
	#define IDP2(level,format,p1,p2)				{printf(__LOC__); printf(format,p1,p2);}
	#define IDP3(level,format,p1,p2,p3)				{printf(__LOC__); printf(format,p1,p2,p3);}
	#define IDP4(level,format,p1,p2,p3,p4)			{printf(__LOC__); printf(format,p1,p2,p3,p4);}
	#define IDP5(level,format,p1,p2,p3,p4,p5)		{printf(__LOC__); printf(format,p1,p2,p3,p4,p5);}
	#define IDP6(level,format,p1,p2,p3,p4,p5,p6)	{printf(__LOC__); printf(format,p1,p2,p3,p4,p5,p6);}
	#define IFLDP()									{printf(__LOC__);}
	#define ITRACE(a)								printf(__LOC__ a)
	#define IERR(a)									perror(__LOC__ a)
 #endif /* __linux__ */


#else

	#define IDP_BUFFER								NULL

	#define IDP(level,string)
	#define IDP1(level,format,p1)
	#define IDP2(level,format,p1,p2)
	#define IDP3(level,format,p1,p2,p3)
	#define IDP4(level,format,p1,p2,p3,p4)
	#define IDP5(level,format,p1,p2,p3,p4,p5)
	#define IDP6(level,format,p1,p2,p3,p4,p5,p6)
	#define IFLDP()
	#define ITRACE(string)
	#define IERR(string)
	#define IFLERR()
	#define IFLERR1(a)
	#define IWARN(string)
	#define IFLWARN()
	#define IFLWARN1(a)

	#define IDBP(level,b,l)
#endif


/*
	bZ[W̃ۑ
*/
#if (defined(__ITFDEBUG__) && defined(__ITFDEBUG_MEMORY_PRINT__))

	#define MAX_DEBUG_STR_MEM 						(1024)					/**< ۑpobt@̃TCY */
	#define IMDP_BUFFER								ITFDEBUG_Get_Buffer()	/**< fobOo͗pobt@ */

	extern void ITFDEBUG_Init_Memory();
	extern void ITFDEBUG_Put_Memory(int8_t *str);
	extern void ITFDEBUG_Put_MemoryClear(void);
	extern void ITFDEBUG_Put_MemoryOut(void);

	#define IMDPINIT()								ITFDEBUG_Init_Memory()
	#define IMDP(level,string)						ITFDEBUG_Put_Memory((int8_t *)string)
	#define IMDP1(level,format,p1)					{sprintf(IMDP_BUFFER,format,p1);IMDP(level,IMDP_BUFFER);}
	#define IMDP2(level,format,p1,p2)				{sprintf(IMDP_BUFFER,format,p1,p2);IMDP(level,IMDP_BUFFER);}
	#define IMDP3(level,format,p1,p2,p3)			{sprintf(IMDP_BUFFER,format,p1,p2,p3);IMDP(level,IMDP_BUFFER);}
	#define IMDP4(level,format,p1,p2,p3,p4)			{sprintf(IMDP_BUFFER,format,p1,p2,p3,p4);IMDP(level,IMDP_BUFFER);}
	#define IMDP5(level,format,p1,p2,p3,p4,p5)		{sprintf(IMDP_BUFFER,format,p1,p2,p3,p4,p5);IMDP(level,IMDP_BUFFER);}
	#define IMDP6(level,format,p1,p2,p3,p4,p5,p6)	{sprintf(IMDP_BUFFER,format,p1,p2,p3,p4,p5,p6);IMDP(level,IMDP_BUFFER);}
	#define IMFLDP()								{sprintf(IMDP_BUFFER, __FILE__ "(%d)" ICRLF, __LINE__);IMDP(IMDP_BUFFER);}
	#define IMTRACE(string)							{IMDP(IDL_TRACE,string);}
	#define IMERR(string)							{IMDP(IDL_ERROR,"ERROR>");IMDP(IDL_ERROR,string);}
	#define IMFLERR()								{sprintf(IMDP_BUFFER, ICRLF "ERROR>" __FILE__ "(%d)" ICRLF, __LINE__);IMDP(IDL_ERROR,IMDP_BUFFER);}
	#define IMFLERR1(a)								{sprintf(IMDP_BUFFER, ICRLF "ERROR>" __FILE__ "(%d): %d" ICRLF, __LINE__, a);IMDP(IDL_ERROR,IMDP_BUFFER);}
	#define IMWARN(string)							{IMDP(IDL_WARNING,"WARNING>");IMDP(IDL_WARNING,string);}
	#define IMFLWARN()								{sprintf(IMDP_BUFFER, ICRLF "WARNING>" __FILE__ "(%d)" ICRLF, __LINE__);IMDP(IDL_WARNING,IMDP_BUFFER);}
	#define IMFLWARN1(a)							{sprintf(IMDP_BUFFER, ICRLF "WARNING>" __FILE__ "(%d): %d" ICRLF, __LINE__, a);IMDP(IDL_WARNING,IMDP_BUFFER);}

	#define IMDPCLR()								ITFDEBUG_Put_MemoryClear()
	#define IMDPOUT()								ITFDEBUG_Put_MemoryOut()

#else

	#define IMDPINIT()
	#define IMDP(level,string)
	#define IMDP1(level,format,p1)
	#define IMDP2(level,format,p1,p2)
	#define IMDP3(level,format,p1,p2,p3)
	#define IMDP4(level,format,p1,p2,p3,p4)
	#define IMDP5(level,format,p1,p2,p3,p4,p5)
	#define IMDP6(level,format,p1,p2,p3,p4,p5,p6)
	#define IMFLDP()
	#define IMTRACE(string)
	#define IMERR(string)
	#define IMFLERR()
	#define IMFLERR1(a)
	#define IMWARN(string)
	#define IMFLWARN()
	#define IMFLWARN1(a)

	#define IMDPCLR()
	#define IMDPOUT()

#endif



/*
	AT[g
*/
#if (defined(__ITFDEBUG__) && defined(__ITFDEBUG_ASSERT__))
	#define IASSERT(a)			\
	{							\
		if (!(a)){				\
			IDP1(IDL_ALL, __FILE__ "(%d)" ": ASSERTION FAILED!!!!\r\n", __LINE__);		\
			OSAPI_Tslp_Tsk(-1);		\
		}							\
	}
#else
	#define IASSERT(a)
#endif


/*
	_v
*/
#if (defined(__ITFDEBUG__) && defined(__ITFDEBUG_DUMP__))
	extern void ITFDEBUG_Dump8(uint8_t *adr, uint32_t count);
	extern void ITFDEBUG_Dump16(uint16_t *adr, uint32_t count);
	extern void ITFDEBUG_Dump32(uint32_t *adr, uint32_t count);
	extern void ITFDEBUG_DumpB(uint32_t data, int32_t nbit, int32_t count);

	#define IDUMP8(buffer,count)				ITFDEBUG_Dump8((uint8_t *)(buffer), count)
	#define IDUMP16(buffer,count)				ITFDEBUG_Dump16((uint16_t *)(buffer), count)
	#define IDUMP32(buffer,count)				ITFDEBUG_Dump32((uint32_t *)(buffer), count)
	#define IDUMPB(a,b,c)						ITFDEBUG_DumpB((uint32_t)(a), (int32_t)(b), (int32_t)(c))
#else
	#define IDUMP8(buffer,count)
	#define IDUMP16(buffer,count)
	#define IDUMP32(buffer,count)
	#define IDUMPB(a,b,c)
#endif





/*
	p[^`FbN
*/
#ifndef __ITFPRMNOCHK__
	#define ITFPRMCHK(a,b)			\
	{								\
		if ((a))	return b;		\
	}

	#define ITFPRMCHK_RET(a,b)		\
	{								\
		if ((a))	return b;		\
	}

#else
	#define ITFPRMCHK(a,b)			
	#define ITFPRMCHK_RET(a,b)		
#endif


#ifdef __cplusplus
}
#endif
#endif	/* __ITFDEBUG_H__ */
