/**********************************************************************/
/**
 * @ingroup ITFLIB
 * @file itfos.h
 * ITFLIBCu nrۉwb_t@C.
 *
 * @author M.Furuta
 * $Date: 2004/11/16 12:14:01 $
 * $Revision: 1.2 $
 *
 * Copyright (c) 2003-2009 Interface Inc. All Rights reserved.
 * 
 * <pre>
 * --------------------------------------------------------------------
 * ύX
 *  +-------------- ԍ (000 ` 999)
 *  |	  +--------- CĂVXeo[W
 *  |	  | 	+--- VKAύXAǉA폜̕
 *  v	  v 	v
 *  No  Ver   N	  O			
 * ---+-----+----+----------+-------------+----------------------------
 * 000 01.00 VK 2004/02/20 ITF Furuta     VK쐬
 * 001 01.02 ǉ 2004/09/22 ITF Takasaki   ITRON4.0̃VXeR[̑SĂɑΉB
 * 002 01.02 ǉ 2004/11/10 ITF Takasaki   ITRON4.0̒萔ɑΉB
 * 003 01.08 ύX 2006/06/07 ITF Takasaki   \̖̕ύXB
 * 004 01.13 ύX 2009/07/02 ITF Takasaki   uC3ΉB
 * ---+-----+----+----------+-------------+----------------------------
 * </pre>
 */
/**********************************************************************/
#ifndef __ITFOS_H__
#define __ITFOS_H__
#ifdef __cplusplus
extern "C" {
#endif

/*------------------------------------------*/
/*				CN[h				*/
/*------------------------------------------*/

/*------------------------------------------*/
/*				OQ					*/
/*------------------------------------------*/

/*------------------------------------------*/
/*				ϐ					*/
/*------------------------------------------*/

/*------------------------------------------*/
/*				֐					*/
/*------------------------------------------*/

/*------------------------------------------*/
/*				錾						*/
/*------------------------------------------*/



#define ITTA_HLNG     0x0000
#define ITTA_ACT      0x0002
#define ITTA_FPU      0x0100


#define ITTA_TFIFO    0x0000
#define ITTA_TPRI     0x0001
#define ITTA_TPRIR    0x0004


#define ITTMO_POL     0L
#define ITTMO_FEVR    (-1L)
#define ITTMO_NBLK    (-2L)


#define ITTSK_SELF    0
#define ITTSK_NONE    0
#define ITID_AUTO     0


#define ITTPRI_INI    0
#define ITTPRI_SELF   0
#define ITTMIN_TPRI   1


#define ITTTS_RUN     0x0001
#define ITTTS_RDY     0x0002
#define ITTTS_WAI     0x0004
#define ITTTS_SUS     0x0008
#define ITTTS_WAS     0x000c
#define ITTTS_DMT     0x0010


#define ITTTEX_ENA    0x00
#define ITTTEX_DIS    0x01


#define ITTTW_SLP     0x0001
#define ITTTW_DLY     0x0002
#define ITTTW_SEM     0x0004
#define ITTTW_FLG     0x0008
#define ITTTW_SDTQ    0x0010
#define ITTTW_RDTQ    0x0020
#define ITTTW_MBX     0x0040
#define ITTTW_MTX     0x0080
#define ITTTW_SMBF    0x0100
#define ITTTW_MBF     0x0200
#define ITTTW_CAL     0x0400
#define ITTTW_ACP     0x0800
#define ITTTW_RDV     0x1000
#define ITTTW_MPF     0x2000
#define ITTTW_MPL     0x4000


#define ITTA_WSGL     0x0000
#define ITTA_CLR      0x0004
#define ITTA_WMUL     0x0002


#define ITTWF_ANDW    0x0000
#define ITTWF_ORW     0x0001
#define ITTWF_CLR     0x0004


#define ITTA_MFIFO    0x0000
#define ITTA_MPRI     0x0002


#define ITTMIN_MPRI   1


#define ITTA_INHERIT  0x0002
#define ITTA_CEILING  0x0003


#define ITTA_NULL     0


#define ITTA_STA      0x0002
#define ITTA_PHS      0x0004


#define ITTCYC_STP    0x0000
#define ITTCYC_STA    0x0001


#define ITTALM_STP    0x0000
#define ITTALM_STA    0x0001


#define ITTOVR_STP    0x0000
#define ITTOVR_STA    0x0001


#define ITTSS_TSK     0
#define ITTSS_DDSP    1
#define ITTSS_LOC     3
#define ITTSS_INDP    4


#define ITSIZEOF_ALIGN		8
#define ITTSZ_MPL(c,s)		(uint32_t)(((((s)+sizeof(int32_t)+ITSIZEOF_ALIGN-1)&~(ITSIZEOF_ALIGN-1))*(c))+ITSIZEOF_ALIGN)


typedef struct itt_ctsk
{
#if 0
	ITVP_INT exinf;
	ITFP task;
	ITSIZE stksz;
	ITVP stk;
	ITID stkno;					
	UITB itskpri;
#else
	ITATR tskatr;
	ITVP_INT exinf;
	ITFP task;
	ITPRI itskpri;
	ITSIZE stksz;
	ITVP stk;
	ITB *name;
#endif
} ITT_CTSK;

typedef struct itt_csem
{
#if 0
	UITINT isemcnt;
	UITINT maxsem;
#else
	ITATR sematr;
	UITINT isemcnt;
	UITINT maxsem;
	ITB *name;
#endif
} ITT_CSEM;

typedef struct itt_cmbx
{
	ITATR mbxatr;
	ITPRI maxmpri;
	ITVP mprihd;
	ITB *name;
} ITT_CMBX;

typedef struct itt_msg
{
#ifdef __KERNEL_UC3_COMPACT__
	struct itt_msg *msgque;
	ITVB msgcont[ITMSGS] ;
#else
	struct itt_msg *next;
	ITVB msgcont[ITMSGS] ;
#endif
} ITT_MSG;

typedef struct itt_cmpf
{
#if 0
	UITINT blkcnt;
	UITINT blfsz;
	ITVP mpf;
#else
	ITATR mpfatr;
	UITINT blkcnt;
	UITINT blfsz;
	ITVP mpf;
	ITB *name;
#endif
} ITT_CMPF;

typedef struct itt_cmpl
{
	ITATR mplatr;
	UITINT mplsz;
	ITVP mpl;
	ITB *name;
} ITT_CMPL;

typedef struct
{
#ifdef __KERNEL_UC3_COMPACT__
	UITW utime;
	UITW ltime;
#else
	ITH utime;
	UITW ltime;
#endif
} ITSYSTIM;

typedef struct itt_dinh
{
	ITATR inhatr;
	ITFP inthdr;
	UITINT imask;
} ITT_DINH;

typedef struct itt_cycc
{
#if 0
	ITVP_INT exinf;
	ITFP cychdr;
	ITRELTIM cyctim;
	ITRELTIM cycphs;
#else
	ITATR cycatr;
	ITVP_INT exinf;
	ITFP cychdr;
	ITRELTIM cyctim;
	ITRELTIM cycphs;
#endif
} ITT_CCYC;

typedef struct itt_rtsk
{
#ifdef __KERNEL_UC3_COMPACT__
	ITSTAT tskstat;
	ITPRI tskpri;
	ITPRI tskbpri;
	ITSTAT tskwait;
	ITID wid;
	ITTMO lefttmo;
	ITUINT actcnt;
	ITUINT wupcnt;
	ITUINT suscnt;
#else
	ITSTAT tskstat;
	ITPRI tskpri;
	ITPRI tskbpri;
	ITSTAT tskwait;
	ITID wid;
	ITTMO lefttmo;
	ITUINT actcnt;
	ITUINT wupcnt;
	ITUINT suscnt;
	ITVP exinf;
	ITATR tskatr;
	ITFP task;
	ITPRI itskpri;
	ITINT stksz;
#endif
} ITT_RTSK;


typedef struct itt_rtst
{
	ITSTAT tskstat;
	ITSTAT tskwait;
} ITT_RTST;

typedef struct itt_dtex
{
	ITATR texatr;
	ITFP texrtn;
} ITT_DTEX;


typedef struct itt_rtex
{
	ITSTAT texstat;
	ITTEXPTN pndptn;
} ITT_RTEX;

typedef struct itt_rsem
{
	ITID wtskid;
	ITUINT semcnt;
} ITT_RSEM;

typedef struct itt_cflg
{
#if 0
	ITFLGPTN iflgptn;
#else
	ITATR flgatr;
	ITFLGPTN iflgptn;
	ITB *name;
#endif
} ITT_CFLG;

typedef struct itt_rflg
{
	ITID wtskid;
	ITFLGPTN flgptn;
} ITT_RFLG;

typedef struct itt_cdtq
{
#if 0
	ITUINT dtqcnt;
	ITVP dtq;
#else
	ITATR dtqatr;
	ITUINT dtqcnt;
	ITVP dtq;
	ITB *name;
#endif
} ITT_CDTQ;

typedef struct itt_rdtq
{
	ITID stskid;
	ITID rtskid;
	ITUINT sdtqcnt;
} ITT_RDTQ;

typedef struct itt_rmbx
{
	ITID wtskid;
	ITT_MSG *pk_msg;
} ITT_RMBX;

typedef struct itt_cmtx
{
	ITATR mtxatr;
	ITPRI ceilpri;
	ITB *name;
} ITT_CMTX;

typedef struct itt_rmtx
{
	ITID htskid;
	ITID wtskid;
} ITT_RMTX;

typedef struct itt_cmbf
{
	ITATR mbfatr;
	ITUINT maxmsz;
	ITSIZE mbfsz;
	ITVP mbf;
	ITB *name;
} ITT_CMBF;

typedef struct itt_rmbf
{
	ITID stskid;
	ITID rtskid;
	ITUINT smsgcnt;
	ITSIZE fmbfsz;
} ITT_RMBF;

typedef struct itt_cpor
{
	ITATR poratr;
	ITUINT maxcmsz;
	ITUINT maxrmsz;
	ITB *name;
} ITT_CPOR;

typedef struct itt_rpor
{
	ITID ctskid;
	ITID atskid;
} ITT_RPOR;

typedef struct itt_rrdv
{
	ITID wtskid;
} ITT_RRDV;

typedef struct itt_rmpf
{
	ITID wtskid;
	ITUINT frbcnt;
} ITT_RMPF;

typedef struct itt_rmpl
{
	ITID wtskid;
	ITSIZE fmplsz;
	ITUINT fblksz;
} ITT_RMPL;

typedef struct itt_rcyc
{
	ITSTAT cycstat;
	ITRELTIM lefttim;
} ITT_RCYC;


typedef struct itt_calm
{
	ITATR almatr;
	ITVP_INT exinf;
	ITFP almhdr;
} ITT_CALM;

typedef struct itt_ralm
{
	ITSTAT almstat;
	ITRELTIM lefttim;
} ITT_RALM;

typedef struct itt_dovr
{
	ITATR ovratr;
	ITFP ovrhdr;
	ITINTNO intno;
	ITFP ovrclr;
	ITUINT imask;
} ITT_DOVR;

typedef struct itt_rovr
{
	ITSTAT ovrstat;
	ITOVRTIM leftotm;
} ITT_ROVR;

typedef struct itt_rsys
{
	ITINT sysstat;
} ITT_RSYS;

typedef struct itt_cisr
{
	ITATR istatr;
	ITVP_INT exinf;
	ITINTNO intno;
	ITFP isr;
	ITUINT imask;
} ITT_CISR;

typedef struct itt_risr
{
	ITINTNO intno;
	ITUINT imask;
} ITT_RISR;

typedef struct itt_dsvc
{
	ITATR svcatr;
	ITFP svcrtn;
	ITINT parn;
} ITT_DSVC;

typedef struct itt_dexc
{
	ITATR excatr;
	ITFP excchdr;
} ITT_DEXC;

typedef struct itt_rcfg
{
#ifdef __KERNEL_UC3_COMPACT__
	UITH tick;			
	UITH tskpri_max;	
	UITH id_max;		
#else
	ITID tskid_max;
	ITID semid_max;
	ITID flgid_max;
	ITID mbxid_max;
	ITID mbfid_max;
	ITID porid_max;
	ITID mplid_max;
	ITID mpfid_max;
	ITID cycno_max;
	ITID almno_max;
	ITPRI tpri_max;
	ITINT tmrqsz;
	ITINT cycqsz;
	ITINT almqsz;
	ITINT istksz;
	ITINT tstksz;
	ITSIZE sysmsz;
	ITSIZE mplmsz;
	ITSIZE stkmsz;
	ITID dtqid_max;
	ITID mtxid_max;
	ITID isrid_max;
	ITID svcfn_max;
#endif
} ITT_RCFG;

typedef struct itt_rver
{
	UITH maker;
	UITH prid;
	UITH spver;
	UITH prver;
	UITH prno[4];
} ITT_RVER;

/*------------------------------------------*/
/*				vg^Cv				*/
/*------------------------------------------*/
ITER OSAPI_Cre_Tsk(ITID tskid, const ITT_CTSK *pk_ctsk);
ITER_ID OSAPI_Acre_Tsk(const ITT_CTSK *pk_ctsk);
ITER OSAPI_Del_Tsk(ITID tskid);
ITER OSAPI_Act_Tsk(ITID tskid);
ITER OSAPI_Iact_Tsk(ITID tskid);
ITER OSAPI_Can_Act(ITID tskid);
ITER OSAPI_Sta_Tsk(ITID tskid, ITVP_INT stacd);
void OSAPI_Ext_Tsk(void);
void OSAPI_Exd_Tsk(void);
ITER OSAPI_Ter_Tsk(ITID tskid);
ITER OSAPI_Chg_Pri(ITID tskid, ITPRI tskpri);
ITER OSAPI_Get_Pri(ITID tskid, ITPRI *tskpri);
ITER OSAPI_Ref_Tsk(ITID tskid, ITT_RTSK *pk_rtsk);
ITER OSAPI_Ref_Tst(ITID tskid, ITT_RTST *pk_rtst);

ITER OSAPI_Slp_Tsk(void);
ITER OSAPI_Tslp_Tsk(ITTMO tmout);
ITER OSAPI_Wup_Tsk(ITID tskid);
ITER OSAPI_Iwup_Tsk(ITID tskid);
ITER OSAPI_Can_Wup(ITID tskid);
ITER OSAPI_Rel_Wai(ITID tskid);
ITER OSAPI_Irel_Wai(ITID tskid);
ITER OSAPI_Sus_Tsk(ITID tskid);
ITER OSAPI_Rsm_Tsk(ITID tskid);
ITER OSAPI_Frsm_Tsk(ITID tskid);
ITER OSAPI_Dly_Tsk(ITRELTIM dlytim);

ITER OSAPI_Def_Tex(ITID tskid, const ITT_DTEX *pk_dtex);
ITER OSAPI_Ras_Tex(ITID tskid, ITTEXPTN rasptn);
ITER OSAPI_Iras_Tex(ITID tskid, ITTEXPTN rasptn);
ITER OSAPI_Dis_Tex(void);
ITER OSAPI_Ena_Tex(void);
ITBOOL OSAPI_Sns_Tex(void);
ITER OSAPI_Ref_Tex(ITID tskid, ITT_RTEX *pk_rtex);

ITER_ID OSAPI_Cre_Sem(ITID semid, const ITT_CSEM *pk_csem);
ITER_ID OSAPI_Acre_Sem(const ITT_CSEM *pk_csem);
ITER OSAPI_Del_Sem(ITID semid);
ITER OSAPI_Sig_Sem(ITID semid);
ITER OSAPI_Isig_Sem(ITID semid);
ITER OSAPI_Wai_Sem(ITID semid);
ITER OSAPI_Pol_Sem(ITID semid);
ITER OSAPI_Twai_Sem(ITID semid, ITTMO tmout);
ITER OSAPI_Ref_Sem(ITID semid, ITT_RSEM *pk_rsem);

ITER OSAPI_Cre_Flg(ITID flgid,const ITT_CFLG *pk_cflg);
ITER_ID OSAPI_Acre_Flg(const ITT_CFLG *pk_cflg);
ITER OSAPI_Del_Flg(ITID flgid);
ITER OSAPI_Set_Flg(ITID flgid, ITFLGPTN setptn);
ITER OSAPI_Iset_Flg(ITID flgid, ITFLGPTN setptn);
ITER OSAPI_Clr_Flg(ITID flgid, ITFLGPTN clrptn);
ITER OSAPI_Wai_Flg(ITID flgid, ITFLGPTN waiptn, ITMODE wfmode, ITUINT *p_flgptn);
ITER OSAPI_Pol_Flg(ITID flgid, ITFLGPTN waiptn, ITMODE wfmode, ITFLGPTN *p_flgptn);
ITER OSAPI_Twai_Flg(ITID flgid, ITFLGPTN waiptn, ITMODE wfmode, ITFLGPTN *p_flgptn, ITTMO tmout);
ITER OSAPI_Ref_Flg(ITID flgid, ITT_RFLG *pk_rflg);

ITER OSAPI_Cre_Dtq(ITID dtqid, const ITT_CDTQ *pk_cdtq);
ITER_ID OSAPI_Acre_Dtq(const ITT_CDTQ *pk_cdtq);
ITER OSAPI_Del_Dtq(ITID dtqid);
ITER OSAPI_Snd_Dtq(ITID dtqid, ITVP_INT data);
ITER OSAPI_Psnd_Dtq(ITID dtqid, ITVP_INT data);
ITER OSAPI_Ipsnd_Dtq(ITID dtqid, ITVP_INT data);
ITER OSAPI_Tsnd_Dtq(ITID dtqid, ITVP_INT data, ITTMO tmout);
ITER OSAPI_Fsnd_Dtq(ITID dtqid, ITVP_INT data);
ITER OSAPI_Ifsnd_Dtq(ITID dtqid, ITVP_INT data);
ITER OSAPI_Rcv_Dtq(ITID dtqid, ITVP_INT *p_data);
ITER OSAPI_Prcv_Dtq(ITID dtqid, ITVP_INT *p_data);
ITER OSAPI_Trcv_Dtq(ITID dtqid, ITVP_INT *p_data, ITTMO tmout);
ITER OSAPI_Ref_Dtq(ITID dtqid, ITT_RDTQ *pk_rdtq);

ITER OSAPI_Cre_Mbx(ITID mbxid, const ITT_CMBX *pk_cmbx);
ITER_ID OSAPI_Acre_Mbx(const ITT_CMBX *pk_cmbx);
ITER OSAPI_Del_Mbx(ITID mbxid);
ITER OSAPI_Snd_Mbx(ITID mbxid, ITT_MSG *pk_msg);
ITER OSAPI_Rcv_Mbx(ITID mbxid, ITT_MSG **pk_msg);
ITER OSAPI_Prcv_Mbx(ITID mbxid, ITT_MSG **ppk_msg);
ITER OSAPI_Trcv_Mbx(ITID mbxid, ITT_MSG **pk_msg, ITTMO tmout);
ITER OSAPI_Ref_Mbx(ITID mbxid, ITT_RMBX *pk_rmbx);

ITER OSAPI_Cre_Mtx(ITID mtxid, const ITT_CMTX *pk_cmtx);
ITER_ID OSAPI_Acre_Mtx(const ITT_CMTX *pk_cmtx);
ITER OSAPI_Del_Mtx(ITID mtxid);
ITER OSAPI_Loc_Mtx(ITID mtxid);
ITER OSAPI_Ploc_Mtx(ITID mtxid);
ITER OSAPI_Tloc_Mtx(ITID mtxid, ITTMO tmout);
ITER OSAPI_Unl_Mtx(ITID mtxid);
ITER OSAPI_Ref_Mtx(ITID mtxid, ITT_RMTX *pk_rmtx);

ITER OSAPI_Cre_Mbf(ITID mbfid, const ITT_CMBF *pk_cmbf);
ITER_ID OSAPI_Acre_Mbf(const ITT_CMBF *pk_cmbf);
ITER OSAPI_Del_Mbf(ITID mbfid);
ITER OSAPI_Snd_Mbf(ITID mbfid, ITVP msg, ITUINT msgsz);
ITER OSAPI_Psnd_Mbf(ITID mbfid, ITVP msg, ITUINT msgsz);
ITER OSAPI_Tsnd_Mbf(ITID mbfid, ITVP msg, ITUINT msgsz, ITTMO tmout);
ITER_UINT OSAPI_Rcv_Mbf(ITID mbfid, ITVP msg);
ITER_UINT OSAPI_Prcv_Mbf(ITID mbfid, ITVP msg);
ITER_UINT OSAPI_Trcv_Mbf(ITID mbfid, ITVP msg, ITTMO tmout);
ITER OSAPI_Ref_Mbf(ITID mbfid, ITT_RMBF *pk_rmbf);

ITER OSAPI_Cre_Por(ITID porid, const ITT_CPOR *pk_cpor);
ITER_ID OSAPI_Acre_Por(const ITT_CPOR *pk_cpor);
ITER OSAPI_Del_Por(ITID porid);
ITER_UINT OSAPI_Cal_Por(ITID porid, ITRDVPTN calptn, ITVP msg, ITUINT cmsgsz);
ITER_UINT OSAPI_Tcal_Por(ITID porid, ITRDVPTN calptn, ITVP msg, ITUINT cmsgsz, ITTMO tmout);
ITER_UINT OSAPI_Acp_Por(ITID porid, ITRDVPTN acpptn, ITRDVNO *p_rdvno, ITVP msg);
ITER_UINT OSAPI_Pacp_Por(ITID porid, ITRDVPTN acpptn, ITRDVNO *p_rdvno, ITVP msg);
ITER_UINT OSAPI_Tacp_Por(ITID porid, ITRDVPTN acpptn, ITRDVNO *p_rdvno, ITVP msg, ITTMO tmout);
ITER OSAPI_Fwd_Por(ITID porid, ITRDVPTN calptn, ITRDVNO rdvno, ITVP msg, ITUINT cmsgsz);
ITER OSAPI_Rpl_Rdv(ITRDVNO rdvno, ITVP msg, ITUINT rmsgsz);
ITER OSAPI_Ref_Por(ITID porid, ITT_RPOR *pk_rpor);
ITER OSAPI_Ref_Rdv(ITRDVNO rdvno, ITT_RRDV *pk_rrdv);

ITER OSAPI_Cre_Mpf(ITID mpfid, const ITT_CMPF *pk_cmpf);
ITER_ID OSAPI_Acre_Mpf(const ITT_CMPF *pk_cmpf);
ITER OSAPI_Del_Mpf(ITID mpfid);
ITER OSAPI_Get_Mpf(ITID mpfid, ITVP *p_blf);
ITER OSAPI_Pget_Mpf(ITID mpfid, ITVP *p_blf);
ITER OSAPI_Tget_Mpf(ITID mpfid, ITVP *p_blf, ITTMO tmout);
ITER OSAPI_Rel_Mpf(ITID mpfid, ITVP blk);
ITER OSAPI_Ref_Mpf(ITID mpfid, ITT_RMPF *pk_rmpf);

ITER OSAPI_Cre_Mpl(ITID mplid, const ITT_CMPL *pk_cmpl);
ITER_ID OSAPI_Acre_Mpl(const ITT_CMPL *pk_cmpl);
ITER OSAPI_Del_Mpl(ITID mplid);
ITER OSAPI_Get_Mpl(ITID mplid, UITINT blksz, ITVP *p_blk);
ITER OSAPI_Pget_Mpl(ITID mplid, UITINT blksz, ITVP *p_blk);
ITER OSAPI_Tget_Mpl(ITID mplid, UITINT blksz, ITVP *p_blk, ITTMO tmout);
ITER OSAPI_Rel_Mpl(ITID mplid, ITVP blk);
ITER OSAPI_Ref_Mpl(ITID mplid, ITT_RMPL *pk_rmpl);

ITER OSAPI_Set_Tim(ITSYSTIM *p_systim);
ITER OSAPI_Get_Tim(ITSYSTIM *pk_systim);
void OSAPI_Isig_Tim(void);

ITER OSAPI_Cre_Cyc(ITID cycid, const ITT_CCYC *pk_ccyc);
ITER_ID OSAPI_Acre_Cyc(const ITT_CCYC *pk_ccyc);
ITER OSAPI_Del_Cyc(ITID cycid);
ITER OSAPI_Sta_Cyc(ITID cycid);
ITER OSAPI_Stp_Cyc(ITID cycid);
ITER OSAPI_Ref_Cyc(ITID cycid, ITT_RCYC *pk_rcyc);

ITER OSAPI_Cre_Alm(ITID almid, const ITT_CALM *pk_calm);
ITER_ID OSAPI_Acre_Alm(const ITT_CALM *pk_calm);
ITER OSAPI_Del_Alm(ITID almid);
ITER OSAPI_Sta_Alm(ITID almid, ITRELTIM almtim);
ITER OSAPI_Stp_Alm(ITID almid);
ITER OSAPI_Ref_Alm(ITID almid, ITT_RALM *pk_ralm);

ITER OSAPI_Def_Ovr(const ITT_DOVR *pk_dovr);
ITER OSAPI_Sta_Ovr(ITID tskid, ITOVRTIM ovrtim);
ITER OSAPI_Stp_Ovr(ITID tskid);
ITER OSAPI_Ref_Ovr(ITID tskid, ITT_ROVR *pk_rovr);

ITER OSAPI_Rot_Rdq(ITPRI tskpri);
ITER OSAPI_Irot_Rdq(ITPRI tskpri);
ITER OSAPI_Get_Tid(ITID *p_tskid);
ITER OSAPI_Iget_Tid(ITID *p_tskid);
ITER OSAPI_Loc_Cpu(void);
ITER OSAPI_Iloc_Cpu(void);
ITER OSAPI_Unl_Cpu(void);
ITER OSAPI_Iunl_Cpu(void);
ITER OSAPI_Dis_Dsp(void);
ITER OSAPI_Ena_Dsp(void);
ITBOOL OSAPI_Sns_Ctx(void);
ITBOOL OSAPI_Sns_Loc(void);
ITBOOL OSAPI_Sns_Dsp(void);
ITBOOL OSAPI_Sns_Dpn(void);
ITER OSAPI_Ref_Sys(ITT_RSYS *pk_rsys);

ITER OSAPI_Def_Inh(ITINHNO inhno, const ITT_DINH *pk_dinh);
ITER OSAPI_Cre_Isr(ITID isrid, const ITT_CISR *pk_cisr);
ITER_ID OSAPI_Acre_Isr(const ITT_CISR *pk_cisr);
ITER OSAPI_Del_Isr(ITID isrid);
ITER OSAPI_Ref_Isr(ITID isrid, ITT_RISR *pk_risr);
ITER OSAPI_Dis_Int(ITINTNO intno);
ITER OSAPI_Ena_Int(ITINTNO intno);
ITER OSAPI_Chg_Ixx(ITIXXXX ixxxx);
ITER OSAPI_Get_Ixx(ITIXXXX *p_ixxxx);

ITER OSAPI_Def_Svc(ITFN fncd, const ITT_DSVC *pk_dsvc);
ITER_UINT OSAPI_Cal_Svc(ITFN fncd, ITVP_INT par1, ITVP_INT par2, ...);

ITER OSAPI_Def_Exc(ITEXCNO excno, ITT_DEXC *pk_dexc);
ITER OSAPI_Ref_Cfg(ITT_RCFG *pk_rcfg);
ITER OSAPI_Ref_Ver(ITT_RVER *pk_ver);



#ifdef __cplusplus
}
#endif
#endif
