/**********************************************************************/
/**
 * @ingroup ITFLIB
 * @file itftypes.h
 * ITFLIBCu vg^Cvwb_t@C.
 *
 * @author M.Furuta
 * $Date: 2004/11/08 08:05:59 $
 * $Revision: 1.1.1.1 $
 *
 * Copyright (c) 2003-2004 Interface Inc. All Rights reserved.
 * 
 * <pre>
 * --------------------------------------------------------------------
 * ύX
 *  +-------------- ԍ (000 ` 999)
 *  |	  +--------- CĂVXeo[W
 *  |	  | 	+--- VKAύXAǉA폜̕
 *  v	  v 	v
 *  No  Ver   N	  O			
 * ---+-----+----+----------+-------------+----------------------------
 * 000 01.00 VK 2004/02/20 ITF Furuta     VK쐬
 * 001 01.01 C 2004/09/07 ITF Takasaki   BIT`ToppersΉ폜B
 * 002 01.02 ǉ 2004/09/22 ITF Takasaki   ITRON4.0̃VXeR[̑SĂɑΉB
 * 003 01.03 ύX 2005/03/11 ITF Takasaki   typedef ITH ITTMO; -> typedef ITW ITTMO;B
 * 004 01.07 ύX 2005/10/07 ITF Takasaki   ITUINTunsigned intɕύXB
 * ---+-----+----+----------+-------------+----------------------------
 * </pre>
 */
/**********************************************************************/
#ifndef __ITFTYPES_H__
 #define __ITFTYPES_H__
#ifdef __cplusplus
extern "C" {
#endif
/*------------------------------------------*/
/*				CN[h				*/
/*------------------------------------------*/

/*------------------------------------------*/
/*				OQ					*/
/*------------------------------------------*/

/*------------------------------------------*/
/*				ϐ					*/
/*------------------------------------------*/

/*------------------------------------------*/
/*				֐					*/
/*------------------------------------------*/

/*------------------------------------------*/
/*				錾						*/
/*------------------------------------------*/

#ifndef WIN32
typedef long			BOOLEAN;
#endif

#ifndef linux
typedef signed char		int8_t;
typedef signed short	int16_t;
typedef signed long		int32_t;

typedef unsigned char	uint8_t;
typedef unsigned short	uint16_t;
typedef unsigned long	uint32_t;
#else
 #ifndef __int8_t_defined
 #define __int8_t_defined
typedef char int8_t;
typedef short int16_t;
typedef int int32_t;
 #endif /* __int8_t_defined */

typedef unsigned char	uint8_t;
typedef unsigned short	uint16_t;
typedef unsigned int	uint32_t;
#endif /* linux */

#ifndef TRUE
 #define TRUE			(1)
#endif
#ifndef FALSE
 #define FALSE			(0)
#endif
#ifndef NULL
 #define NULL			((void *)0)
#endif
#ifndef ON
 #define ON				(1)
#endif
#ifndef OFF
 #define OFF			(0)
#endif
#ifndef HIGH
 #define HIGH			(1)
#endif
#ifndef LOW
 #define LOW			(0)
#endif

#define BIT0			0x00000001
#define BIT1			0x00000002
#define BIT2			0x00000004
#define BIT3			0x00000008
#define BIT4			0x00000010
#define BIT5			0x00000020
#define BIT6			0x00000040
#define BIT7			0x00000080
#define BIT8			0x00000100
#define BIT9			0x00000200
#define BIT10			0x00000400
#define BIT11			0x00000800
#define BIT12			0x00001000
#define BIT13			0x00002000
#define BIT14			0x00004000
#define BIT15			0x00008000
#define BIT16			0x00010000
#define BIT17			0x00020000
#define BIT18			0x00040000
#define BIT19			0x00080000
#define BIT20			0x00100000
#define BIT21			0x00200000
#define BIT22			0x00400000
#define BIT23			0x00800000
#define BIT24			0x01000000
#define BIT25			0x02000000
#define BIT26			0x04000000
#define BIT27			0x08000000
#define BIT28			0x10000000
#define BIT29			0x20000000
#define BIT30			0x40000000
#define BIT31			0x80000000


typedef long			ITER;

typedef signed char		ITB;
typedef unsigned char	UITB;
typedef signed short	ITH;
typedef unsigned short	UITH;
typedef signed long		ITW;
typedef unsigned long	UITW;

typedef signed char		ITINT8;
typedef unsigned char	UITINT8;
typedef signed short	ITINT16;
typedef unsigned short	UITINT16;
typedef signed long		ITINT32;
typedef unsigned long	UITINT32;

typedef int32_t			ISTATUS;
typedef ISTATUS			istatus;
typedef int32_t			IHANDLE;
typedef IHANDLE			ihandle;
typedef int32_t			IBOOL;
typedef IBOOL			ibool;
typedef int32_t			ISIZE_T;
typedef ISIZE_T			isize_t;

typedef int				ITINT;
typedef unsigned int	UITINT;
typedef long			ITBOOL;
typedef void*			ITVP;
typedef ITVP			ITVP_INT;
typedef char			ITVB;
typedef void			( *ITFP)();
typedef	ITINT			ITPRI;
typedef UITINT			ITATR;
#define ITMSGS			16
typedef ITINT			ITID;
typedef ITID			ITER_ID;
typedef UITINT			ITINHNO;
#if defined(__KERNEL_NORTI_V4__)
	#define ITINTHDR		INTHDR
#elif defined(__KERNEL_TOPPERS__)
	#define ITINTHDR		void
#else
	#define ITINTHDR		void
#endif

/* OSɂshort/long̐U蕪͍sȂ */
typedef unsigned long	ITSIZE;
typedef ITW				ITTMO;
typedef ITW				ITDLYTIME;
typedef ITDLYTIME		ITRELTIM;

#ifndef	LOCAL
#define	LOCAL	static 
#endif

#ifndef	PUBLIC
#define	PUBLIC
#endif

typedef unsigned int ITUINT;

typedef ITINT ITFN;
typedef ITINT ITRDVNO;
typedef ITUINT ITRDVPTN;
typedef ITUINT ITMODE;
typedef ITUINT ITSTAT;
typedef ITINT ITER_UINT;
typedef ITUINT ITTEXPTN;
typedef ITUINT ITFLGPTN;
typedef ITUINT ITINTNO;

/* OSɂshort/long̐U蕪͍sȂ */
typedef ITDLYTIME ITOVRTIM;

typedef ITUINT ITIXXXX;
typedef ITUINT ITEXCNO;

#ifdef __cplusplus
}
#endif
#endif /* __ITFTYPES_H__ */
