/**********************************************************************/
/**
 * @ingroup SINGLEHOST_API
 * @file singlehostapi.h
 * ITF-SINGLEHOST API `t@C.
 *
 * @author  z
 * $Date: 2005/07/01 $
 * $Revision: 1.0 $
 *
 * Copyright (c) 2005-2006 Interface Inc. All Rights reserved.
 *
 * <pre>
 * --------------------------------------------------------------------
 * ύX
 *  +-------------- ԍ (000 ` 999)
 *  |	  +--------- CĂVXeo[W
 *  |	  | 	+--- VKAύXAǉA폜̕
 *  v	  v 	v
 *  No  Ver   N	  O			
 * ---+-----+----+----------+-------------+----------------------------
 * 000 01.00 VK 2005/07/01 ITF Endo      VK쐬
 * 001 01.01 ύX 2005/07/19 ITF Endo      Usb_Host_Get\Driver_Information() ̍폜,
 *                                         ITFEasyHost_Version() ̒ǉ
 * 002 01.04 ύX 2006/12/07 ITF Endo      ^C}ʒmݒ\Ȃ悤ɕύX
 * 003 01.04 ύX 2006/12/07 ITF Endo      nh hc_interrupt() J
 * 004 01.08 ύX 2007/03/23 ITF Endo      class_match_table_t  bcdDevice  uint8_t 
 *                                         uint16_t ɏC
 * ---+-----+----+----------+-------------+----------------------------
 * </pre>
 */
/**********************************************************************/
#ifndef SINGLEHOSTAPI_H__
#define SINGLEHOSTAPI_H__

#ifdef __cplusplus
extern "C" {
#endif

/*------------------------------------------*/
/*				CN[h				*/
/*------------------------------------------*/

#include "itflib.h"

/*------------------------------------------*/
/*				錾						*/
/*------------------------------------------*/

/**
 * @name	USB NXvtO`
 *
 *			class_match_table_t ̗vf̂NXv̏Ƃėp̂
 *			NUSB_MATCH_*  or  class_match_table_t::flags ɐݒ肷.
 *
 * @{
 */
#define NUSB_MATCH_DEVICE_CLASS			((uint32_t)1 << 0)	/**< foCXNX             */
#define NUSB_MATCH_DEVICE_SUBCLASS		((uint32_t)1 << 1)	/**< foCXTuNX         */
#define NUSB_MATCH_DEVICE_PROTOCOL		((uint32_t)1 << 2)	/**< foCXvgR         */
#define NUSB_MATCH_IDVENDOR				((uint32_t)1 << 3)	/**< x_[ ID                */
#define NUSB_MATCH_IDPRODUCT			((uint32_t)1 << 4)	/**< v_Ng ID              */
#define NUSB_MATCH_BCDDEVICE			((uint32_t)1 << 5)	/**< BCD foCX               */
#define NUSB_MATCH_INTERFACE_CLASS		((uint32_t)1 << 6)	/**< C^[tFCXNX     */
#define NUSB_MATCH_INTERFACE_SUBCLASS	((uint32_t)1 << 7)	/**< C^[tFCXTuNX */
#define NUSB_MATCH_INTERFACE_PROTOCOL	((uint32_t)1 << 8)	/**< C^[tFCXvgR */
/** @} */

/**
 * @name	NXR[h`
 *
 * @{
 */
#define NUSB_HID_INTERFACE_CLASS			0x03	/**< HIDNX̃C^[tFCXNXR[h		*/
#define NUSB_HID_INTERFACE_SUBCLASS			0x01	/**< HIDNX̃C^[tFCXTuNXR[h	*/
#define NUSB_HID_KBD_INTERFACE_PROTOCOL		0x01	/**< HID(keyboard)NX̃C^[tFCXvgRR[h	*/
#define NUSB_HID_MOUSE_INTERFACE_PROTOCOL	0x02	/**< HID(mouse)NX̃C^[tFCXvgRR[h		*/

#define NUSB_STORAGE_INTERFACE_CLASS		0x08	/**< MASS STORAGENX̃C^[tFCXNXR[h		*/
#define NUSB_STORAGE_INTERFACE_SUBCLASS		0x00	/**< MASS STORAGENX̃C^[tFCXTuNXR[h	*/
/**
 * @}
 */

/**
 * @brief NXv\
 */
typedef struct {
	uint32_t flags;					/**< v (NUSB_MATCH_xxx  OR) */
	uint8_t  bDeviceClass;			/**< foCXNX                  */
	uint8_t  bDeviceSubClass;		/**< foCXTuNX              */
	uint8_t  bDeviceProtocol;		/**< foCXvgR              */
	uint16_t idVendor;				/**< Vendor ID                       */
	uint16_t idProduct;				/**< Product ID                      */
	uint16_t bcdDevice;				/**< BCD foCX                    */
	uint8_t  bInterfaceClass;		/**< C^[tFCXNX          */
	uint8_t  bInterfaceSubClass;	/**< C^[tFCXTuNX      */
	uint8_t  bInterfaceProtocol;	/**< C^[tFCXvgR      */
} class_match_table_t;

/**
 * @brief R[obN[`^`
 */
typedef void (*pf_callback_t)(ihandle, int32_t, void*);

/**
 * @brief	NX`\
 *
 *			foCX class_name pĈȉ̒ʂݒ肳.
 *
 *			 :\n
 *			class_name "\\DEV" ̂Ƃ
 *			foCX "\\\\\\USB\\DEV\\XXXX" (XXXX  0000 n܂鐔)
 */
typedef struct {
	class_match_table_t match_table;	/**< v                                         */
	uint16_t            type;			/**< NXR[h NCLASS_USB_*                        */
	const int8_t*       name;			/**< NX (foCX "\\\\\\USB" ɑ) */
	pf_callback_t       pf_callback;	/**< R[obN֐                                 */
} class_def_t;

/**
 * @brief 񓯊p\
 */
struct io_overlapped_t {
	uint32_t code;		/**< R[obN[`ɒʒmR[h */
	uint16_t classtype;	/**< NXR[h                             */
	void*    prm;		/**< R[obN[`̃p[^         */
};

#define FILL_OVERLAPPED(pov, c, cl, p) \
	do {                         \
		(pov)->code      = (c);  \
		(pov)->classtype = (cl); \
		(pov)->prm       = (p);  \
	} while (0)

/**
 * @brief 񓯊R[obN[`p[^\
 */
struct io_overlapped_result_t {
	istatus  status;		/**<  (Xe[^X)                              */
	uint32_t transferred;	/**<  (oCg)                            */
	uint32_t code;			/**< R[h (io_overlapped_t::code i[)    */
	void*    prm;			/**< p[^ (io_overlapped_t::prm i[) */
};

/**
 * @brief I/O Rg[ (Rg[]) p\
 */
typedef struct _NUSB_CONTROL_T {
	struct {
		uint8_t req_type;		/**< bmRequestType    */
		uint8_t req;			/**< bRequest         */
		uint8_t value_l;		/**< wValue       */
		uint8_t value_h;		/**< wValue       */
		uint8_t index_l;		/**< wIndex       */
		uint8_t index_h;		/**< wIndex       */
		uint8_t length_l;		/**< ]oCg */
		uint8_t length_h;		/**< ]oCg */
	} setup;				/**< ZbgAbvf[^ */
	void *buf;				/**< ]obt@       */
} NUSB_CONTROL_T, *PNUSB_CONTROL_T;

/**
 * @brief USB Gh|CgfBXNv^\
 */
typedef struct ENDPOINT_DESCRIPTOR_T {
	uint8_t bLength;			/**< fBXNv^̃TCY   */
	uint8_t bDescriptorType;	/**< fBXNv^̃^Cv   */
	uint8_t bEndpointAddress;	/**< Gh|CgAhX   */
	uint8_t bmAttributes;		/**<  (BIT1-0:]^Cv) */
	uint8_t wMaxPacketSize_l;	/**< őpPbgTCY   */
	uint8_t wMaxPacketSize_h;	/**< őpPbgTCY   */
	uint8_t bInterval;			/**< |[OԊu           */
} ENDPOINT_DESC, *PENDPOINT_DESC;

/**
 * @brief USB C^[tF[XfBXNv^\
 */
typedef struct INTERFACE_DESCRIPTOR_T {
	uint8_t bLength;			/**< fBXNv^̃TCY           */
	uint8_t bDescriptorType;	/**< fBXNv^̃^Cv           */
	uint8_t bInterfaceNumber;	/**<  INTERFACE \ Index ԍ */
	uint8_t bAlternateSetting;	/**< ֐ݒp̈l               */
	uint8_t bNumEndpoints;		/**< INTERFACE  EP  (O͏)    */
	uint8_t bInterfaceClass;	/**< NXR[h                     */
	uint8_t bInterfaceSubClass;	/**< TuNXR[h                 */
	uint8_t bInterfaceProtocol;	/**< vgRR[h                 */
	uint8_t iInterface;			/**< String_Descriptor  Index       */
} INTERFACE_DESC, *PINTERFACE_DESC;

/**
 * @brief USB RtBM[VfBXNv^\
 */
typedef struct CONFIGURATION_DESCRIPTOR_T {
	uint8_t bLength;				/**< fBXNv^̃TCY         */
	uint8_t bDescriptorType;		/**< fBXNv^̃^Cv         */
	uint8_t wTotalLength_l;			/**< \S (g܂) ̒ */
	uint8_t wTotalLength_h;			/**< \S (g܂) ̒ */
	uint8_t bNumInterface;			/**< \̎C^[tF[X   */
	uint8_t bConfigurationValue;	/**< ̍\I邽߂̈   */
	uint8_t iConfiguration;			/**< String_Descriptor  Index     */
	uint8_t bmAttributes;			/**< \̓                     */
	uint8_t MaxPower;				/**< őoX (2mA P)      */
} CONFIG_DESC, *PCONFIG_DESC;

/**
 * @brief USB foCXfBXNv^\
 */
typedef struct DEVICE_DESCRIPTOR_T {
	uint8_t bLength;			/**< fBXNv^̃TCY                  */
	uint8_t bDescriptorType;	/**< fBXNv^̃^Cv                  */
	uint8_t bcdUSB_l;			/**< BCD \ɂ USB [Xԍ     */
	uint8_t bcdUSB_h;			/**< BCD \ɂ USB [Xԍ     */
	uint8_t bDeviceClass;		/**< NXR[h                            */
	uint8_t bDeviceSubClass;	/**< TuNXR[h                        */
	uint8_t bDeviceProtocol;	/**< vgRR[h                        */
	uint8_t bMaxPacketSize0;	/**< EP0 ̍őpPbgTCY                */
	uint8_t idVendor_l;			/**< Vendor ID (USB IF 蓖Ă)     */
	uint8_t idVendor_h;			/**< Vendor ID (USB IF 蓖Ă)     */
	uint8_t idProduct_l;		/**< Product ID (Vendor 蓖Ă)    */
	uint8_t idProduct_h;		/**< Product ID (Vendor 蓖Ă)    */
	uint8_t bcdDevice_l;		/**< BCD \ɂ DEVICE [Xԍ  */
	uint8_t bcdDevice_h;		/**< BCD \ɂ DEVICE [Xԍ  */
	uint8_t iManufacturer;		/**< String_Descriptor Index ()        */
	uint8_t iProduct;			/**< String_Descriptor Index (i)          */
	uint8_t iSerialNumber;		/**< String_Descriptor Index (ԍ)          */
	uint8_t bNumConfigurations;	/**< \\Ȑ                            */
} DEVICE_DESC, *PDEVICE_DESC ;

/**
 * @brief foCX\
 */
typedef struct _NUSB_DEVICE_INFORMATION {
	uint16_t idVendor;		/* Vendor ID              */
	uint16_t idProduct;		/* Product ID             */
	uint16_t bcdDevice;		/* foCX[Xԍ   */
	uint8_t  dev_addr;		/* foCXAhX       */
	uint8_t  ifnum;			/* C^[tFCXԍ   */
	uint8_t  altnum;		/* ֐ݒ萔             */
	uint8_t  altact;		/* ݂̑֐ݒ         */
	uint8_t  epnum;			/* ݂̑֐ݒ EP  */
	uint8_t  epmax;			/* EP                   */

	uint16_t class_type;	/* NX^Cv           */
	int8_t   dev_name[32];	/* foCX             */
} NUSB_DEVICE_INFORMATION, *PNUSB_DEVICE_INFORMATION;

/**
 * @brief hCo\
 */
typedef struct _NDRIVER_INFORMATION_T {
	int8_t *name;		/**<        */
	int8_t *version;	/**< o[W */
	int8_t *revision;	/**< rW */
} NDRIVER_INFORMATION_T, *PNDRIVER_INFORMATION_T;

/*------------------------------------------*/
/*				Jϐ					*/
/*------------------------------------------*/

/*------------------------------------------*/
/*				J֐					*/
/*------------------------------------------*/

istatus Usb_Host_Open(const int8_t *name, uint32_t flags);																								/**< USBI[v 								*/
istatus Usb_Host_Close(ihandle dev);																													/**< USBN[Y 								*/
int32_t Usb_Host_Ep_Write(ihandle dev, uint32_t epnum, void *outbuf, int32_t outsize, struct io_overlapped_t *pov);										/**< USBEPCg 								*/
int32_t Usb_Host_Ep_Read(ihandle dev, uint32_t epnum, void *inbuf, int32_t insize, struct io_overlapped_t *pov);										/**< USBEP[h 								*/
istatus Usb_Host_Ep_Cancel(ihandle dev, uint32_t epnum);																								/**< USBEP]~ 								*/
int32_t Usb_Host_Control(ihandle dev, NUSB_CONTROL_T *usb_ctrl, struct io_overlapped_t *pov);															/**< USBRg[] 						*/
int32_t Usb_Host_Get_Device_Descriptor(ihandle dev, DEVICE_DESC *devdesc, struct io_overlapped_t *pov);													/**< USBfoCXfBXNv^擾 				*/
int32_t Usb_Host_Get_EndPoint_Descriptor(ihandle dev, ENDPOINT_DESC *epdesc, uint8_t altsetting, uint8_t epnum, struct io_overlapped_t *pov);			/**< USBGh|CgfBXNv^擾 		*/
int32_t Usb_Host_Get_EndPoint_Descriptor_Count(ihandle dev, ENDPOINT_DESC *epdesc, uint8_t altsetting, uint8_t count, struct io_overlapped_t *pov);		/**< USBGh|CgfBXNv^擾 		*/
int32_t Usb_Host_Get_Interface_Descriptor(ihandle dev, INTERFACE_DESC *ifdesc, uint8_t altsetting, struct io_overlapped_t *pov);						/**< USBC^[tFCXfBXNv^擾 		*/
int32_t Usb_Host_Get_Configuration_Descriptor(ihandle dev, CONFIG_DESC *cfgdesc, struct io_overlapped_t *pov);											/**< USBRtBO[VfBXNv^擾 	*/

int32_t Usb_Host_Get_String_Descriptor(ihandle dev, uint16_t langid, uint8_t index, int8_t *buf, uint16_t length, struct io_overlapped_t *pov);			/**< USBXgOfBXNv^擾			*/
int32_t Usb_Host_Get_Others_Descriptor(ihandle dev, uint8_t *buf, int32_t size, uint8_t altsetting, int32_t count, struct io_overlapped_t *pov);		/**< USB̑̃fBXNv^擾				*/

istatus Usb_Host_Init(void);																															/**< USB									*/
istatus Usb_Host_Exit(void);																															/**< USBI									*/
istatus Usb_Host_Get_Device_Information(ihandle dev, NUSB_DEVICE_INFORMATION *info);																	/**< USBfoCX擾						*/
istatus Usb_Host_Search_Device(NUSB_DEVICE_INFORMATION *info, int32_t count);																			/**< USBfoCX擾						*/
int32_t Usb_Host_Get_Device_Count(void);																												/**< USBfoCX擾							*/
istatus Usb_Host_Suspend(void);																															/**< USBTXyh								*/
istatus Usb_Host_Wakeup(void);																															/**< USBEFCNAbv							*/
istatus Usb_Host_Remove(void);																															/**< USBfoCX폜							*/
istatus Usb_Host_Reset(void);																															/**< USBfoCXZbg						*/
istatus Usb_Host_Set_Remote_Wakeup(ihandle dev, ibool bremote, struct io_overlapped_t *pov);															/**< USB[gEFCNAbvݒ				*/
ibool   Usb_Host_Get_Remote_Wakeup(ihandle dev);																										/**< USB[gEFCNAbv擾				*/
istatus Usb_Host_Ep_Reset(ihandle dev, uint32_t epnum, struct io_overlapped_t *pov);																	/**< USBpCvZbg							*/
istatus Usb_Host_Ep_Abort(ihandle dev, uint32_t epnum, struct io_overlapped_t *pov);																	/**< USBpCv~								*/
istatus Usb_Host_Get_Interface(ihandle dev, uint8_t *alternate, struct io_overlapped_t *pov);															/**< GET_INTERFACEs							*/
istatus Usb_Host_Set_Interface(ihandle dev, uint8_t alternate, struct io_overlapped_t *pov);															/**< SET_INTERFACEs							*/
istatus Usb_Host_Get_Status(ihandle dev, uint8_t type, uint16_t target, void *buf, struct io_overlapped_t *pov);										/**< GET_STATUSs								*/
void    Usb_Host_Poll_Event(void);																														/**< Cxg|[O							*/
void    Usb_Host_Notify_Timer(void);																													/**< ^C}ʒm									*/

istatus Usb_Host_Register_Class(const class_def_t* p_class_def);																						/**< NXo^									*/

istatus ITFEasyHost_Version(int16_t* major, int16_t* minor);																							/**< o[Wԍǂݏo						*/


void hc_interrupt(void);	/**< nh */

#ifdef __cplusplus
}
#endif

#endif	/* SINGLEHOSTAPI_H__ */
