/**********************************************************************/
/**
 * @ingroup mini-FILE
 * @file itffile.h
 * [U[AvP[Vpwb_t@C
 *
 * @author T.Negishi
 * $Date: 2007/03/27 00:00:00 $
 * $Revision: 1.0 $
 *
 * Copyright (c) 2007 Interface Inc. All Rights reserved.
 *
 * <pre>
 * --------------------------------------------------------------------
 * ύX
 *  +-------------- ԍ (000 ` 999)
 *  |	  +--------- CĂVXeo[W
 *  |	  | 	+--- VKAύXAǉA폜̕
 *  v	  v 	v
 *  No  Ver   N	  O			
 * ---+-----+----+----------+-------------+----------------------------
 * 000 01.00 VK 2007/12/19 ITF Negishi   VK쐬
 * 001 01.01 ύX 2008/06/27 ITF Negishi   hCuɑΉo悤ɍ\(MOUNT_TAEVENT_INFO)ύX
 * 002 01.02 ύX 2008/10/22 ITF Negishi   ݌n̏폜"__READ_ONLY_API__"`̒ǉ
 * 003       ύX 2009/09/02 ITF Negishi   OSgp^gp̃RpCIvV̒ǉɔC
 * 004 01.03 ǉ 2010/03/27 ITF Negishi   f_unlink()ǉ(__UNLINK_API__)
 * 005       ǉ 2010/04/29 ITF Negishi   ǋL݋@\(__APPEND_WRITE__)p̃oDPBɒǉ
 * ---+-----+----+----------+-------------+----------------------------
 * </pre>
 */
/**********************************************************************/
#ifndef __ITFFILE_H__
 #define __ITFFILE_H__

/*------------------------------------------*/
/*				CN[h				*/
/*------------------------------------------*/
#include	"itffileconfig.h"
#include	"itffileerror.h"
#include	"driverif.h"

/* "fsys_vfat.h"͈ȉ̒`ɈˑAVFAT̒`ȉ
 * \̂ȂǂQƂ邽߂̈ʒuŃCN[hāAtypedef錾sB
 */
typedef	uint32_t		FATSIZE_T;
typedef uint32_t		SECTSIZE_T;									/* LBA24LBA48ɑꍇl */
typedef	int8_t			DIR_ENTRY;									/**< fBNgGg^ */

#if ( defined(__VFAT__) || defined(__VFAT_ASCII__) )
#include	"fsys_vfat.h"
#endif


/*------------------------------------------*/
/*				錾						*/
/*------------------------------------------*/

/**********************************************************************/
/** hCu[^[̍őlw(hCuw)
 *   [U[AvP[VŎgp\ƂhCu[^[̍ől
 *   ftHǵAhCuPƂB
 */
#ifndef __MIN_LETTER__
	#define		__MIN_LETTER__			'C'
#endif
#ifndef __MAX_LETTER__
	#define		__MAX_LETTER__			'C'
#endif

/* ݒ肪ꍇ̓ftHglɋIɕύX */
#ifdef __MIN_LETTER__
 #if ( (__MIN_LETTER__ < 'A') || (__MIN_LETTER__ > 'Z') )
	#undef		__MIN_LETTER__
	#define		__MIN_LETTER__			'C'
 #endif
#endif
#ifdef __MAX_LETTER__
 #if ( (__MAX_LETTER__ < 'A') || (__MAX_LETTER__ > 'Z') || (__MAX_LETTER__ < __MIN_LETTER__) )
	#undef		__MAX_LETTER__
	#define		__MAX_LETTER__			__MIN_LETTER__
 #endif
#endif
#define			MAX_DRIVE				((__MAX_LETTER__-__MIN_LETTER__)+1)		/* hCu */

#ifdef __ASYNCHRONOUS_API__
 #ifdef __DYNAMIC_MEMORY__
  #error Not Supported Model!
 #endif
 #ifdef __FILE_OS_USED__
  #error Not Supported Model!
 #endif
#endif
#ifdef __READ_ONLY_API__
 #ifdef __HIGH_PERFORMANCE__
  #error Not Supported Model!
 #endif
 #ifdef __ASYNCHRONOUS_API__
  #error Not Supported Model!
 #endif
 #ifdef __SEQUENCE_WRITE__
  #error Not Supported Model!
 #endif
#endif

/**********************************************************************/
/** t@CI[v̑w.
 * uf_openṽ[hwɎgp[^
 */
#define		O_RDONLY				0x0000							/* open for reading only */
#ifndef __READ_ONLY_API__
#define		O_WRONLY				0x0001							/* open for writing only */
#define		O_RDWR					0x0002							/* open for reading and writing */
#define		O_APPEND				0x0008							/* writes done at eof */
#define		O_CREAT					0x0100							/* create and open file */
#define		O_EXCL					0x0400							/* open only if file doesn't already exist */
#endif
#define		S_IREAD					0000400							/* read permission, owner */
#define		S_IWRITE				0000200							/* write permission, owner */
#ifdef __SEQUENCE_WRITE__
#define		O_SEQUENCE				0x0800							/* sequence write mode */
#endif

/* find  */
#define		_A_ARCH					0x20							/* A[JCut@C */
#define		_A_HIDDEN				0x02							/* Bt@C */
#define		_A_NORMAL				0x00							/* ʏ̃t@C */
#define		_A_RDONLY				0x01							/* ǂݏop̃t@C */
#define		_A_SUBDIR				0x10							/* TufBNg */
#define		_A_SYSTEM				0x04							/* VXet@C */
#define		_A_VOLID				0x08							/* {[ID */
#define		_A_ALL					(_A_HIDDEN|_A_RDONLY|_A_SUBDIR|_A_SYSTEM) /* Sĕ\ */

/**********************************************************************/
/** LbṼZN^obt@TCY.
 */
#define		BUFSECSIZE				512

/**********************************************************************/
/** [oufBXN̎Oݒf[^.
 * disk_mount̑Tp[^ɐݒ肷f[^̒`
 */
enum {
	DISK_UNREMOVABLE,												/**< Os\(ŒfBXN) */
	DISK_REMOVABLE													/**< O\([oufBXN) */
};

/**********************************************************************/
/** [U[ʒm̃CxgʁD
 * [oufBXN̑}Cxgʒm(disk_mount̃R[obN֐
 * Rp[^)ɐݒ肳f[^̒`
 */
enum {
	EVENT_DISCONNECT,												/**< Cxgʒm */
	EVENT_CONNECT													/**< }Cxgʒm */
};

/**********************************************************************/
/** NX^g.
 * baseƂfat12VXefat16ΉɊgꂽNX^\
 */
typedef	struct	entCluster {
	FATSIZE_T			extFirstclus;								/**< fBNgGg̃NX^ */
	FATSIZE_T			extLstclus1;								/**< ݃ANZXĂNX^m */
	FATSIZE_T			extLstclus2;								/**< ݃I[vĂt@C̃fBNgGg̈̃NX^ */
}CLUSFAC;

/**********************************************************************/
/** foCXp[^ubN.
 * BPBt@CVXeŎgpDPB\
 * _hCuɗpӂ̈łB
 */
typedef void	(*EventDriver)(int8_t,int8_t,int8_t);				/**< hCo[֐|Cg	*/
typedef struct	dvice_parm_block {
#if (MAX_DRIVE > 1)
	int8_t				dpb_drive;									/**< _hCuNo. DPB(A=0,B=1,...) */
#endif
	uint8_t				dpb_cluster_mask;							/**< 1NX^ӂ̃ZN^}XN<br>
																		* 1NX^ӂ̃ZN^ - 1̒lƂ鎖
																		* }XNlƂĎgp<br>
																		*/
	uint8_t				dpb_cluster_shift;							/**< 1NX^ӂ̃ZN^ZoVtg<br>
																		* NX^ZN^ɕϊۂɎgpVtg<br>
																		* ZN^/NX^͕K2ׂ̂ɂȂ̂ŃVtgZ<br>
																		*/
	uint8_t				dpb_FAT_count;								/**< ̃hCuɑ݂FAT */
	int8_t				dpb_first_access;							/**< DPB̊tO<br>
																		* -2 : <br>
																		* -1 : o^ςݏ<br>
																		*  0 : s(}Egς)<br>
																		*  1 : gp\<br>
																		*/
#define		DPB_FAT12				0								/**< FATʒ` */
#define		DPB_FAT16				1
#define		DPB_FAT32				2
	uint8_t				dpb_fattype;								/**< FAT(Ldefineɂĕ\) */
#if (MAX_DRIVE > 1)
	int8_t				deviceno;									/**< foCXʔԍ(hCuNo) */
#endif
	uint16_t			dpb_root_entries;							/**< ̃hCũ[gfBNg̃Gg[ (FAT32ł0Œ) */
	uint16_t			dpb_sector_size;							/**< 1ZN^̃TCY(oCg) */
	uint16_t			clussave;									/**< FAT12ANZX̕NX^No.obt@ */
	SECTSIZE_T			dpb_first_FAT;								/**< ̃hCuFAT̈܂ł̃ZN^ */
	SECTSIZE_T			dpb_first_sector;							/**< NX^No2ɑ΂ZN^ */
	FATSIZE_T			dpb_max_cluster;							/**< ̃hCu̍őNX^No + 1 */
	SECTSIZE_T			dpb_FAT_size;								/**< 1FATӂ̎gpZN^ */
	SECTSIZE_T			dpb_dir_sector;								/**< [gfBNg̊JnZN^(FAT32łdpb_first_sectorƃCR[) */
	FATSIZE_T			dpb_rootstartcluster;						/**< FAT32̏ꍇbpbrootJnNX^Zbg */
	int32_t				clussplit;									/**< FAT12ANZX̕NX^tO */
#define		MAXFAT12				0x00000ff8u						/**< FAT̍ŏINXf[^ */
#define		MAXFAT16				0x0000fff8u
#define		MAXFAT32				0x0ffffff8u
	FATSIZE_T			dpb_lastcluster;							/**< Ō̃NXf[^ */

	SECTSIZE_T			LBAOffset;									/**< hCůJnZN^ԍ<br>
																		*  0ȏ : hCůJnZN^ԍ<br>
																		*  -1    : p[eBV<br>
																		*/
#ifdef __APPEND_WRITE__
	FATSIZE_T			FindCluster;								/**< 󂫗̈̕ۑf[^ */
#endif
	DiskDriver			driver_func;								/**< [U[`hCo֐ */
	EventDriver			callback;									/**< }Cxgʒm(FileSysytem[U[Av) */
	int32_t				driverno;									/**< hCopʔԍ([oufBXN̂ݎgp) */
}DPB;

/**********************************************************************/
/** LbVobt@\.
 * fBXNANZXy邽߂̃obt@Ä̗傫
 * (itffileconfig.hŕύX\)AptH[}Xコ邱ƂoB
 */
typedef struct	buffer_infomation {
	uint8_t				bufdirty;									/**< ̃obt@̏Ԃ܂
																		* -1 ; gp<br>
																		*  0 ; gpŖύX(KvȂ)<br>
																		*  1 ; gpŕύX(Kv)<br>
																		*/
	uint8_t				bufpri;										/**< ̃obt@̗Dx */
	uint8_t				buffat;										/**< FAT̈̃f[^Ȃ̂tO܂
																		*  0 ; FAT̈ł͂Ȃ<br>
																		*  1 ; FAT̈<br>
																		*/
	SECTSIZE_T			bufsecno;									/**< ̃obt@̃ZN^No.(LBA) */
	uint8_t				buffers[BUFSECSIZE] ;						/**< obt@f[^̎ */
}BUFFINFO;

/**********************************************************************/
/** PATHSRCH\.
 * pXT[`Ŏgp\<br>
 */
typedef struct {
	FATSIZE_T			dirstart;									/**< T[`̃fBNgGgJnNX^No. */
#ifdef __SEQUENCE_WRITE__
	FATSIZE_T			dirend;										/**< T[`̐efBNgGgINX^No. */
#endif
	FATSIZE_T			parentdirstart;								/**< T[`̐efBNgGgJnNX^No. */
	FATSIZE_T			clusnum;									/**< ݂̃NX^No. */
	FATSIZE_T			nxtclusnum;									/**< ݃NX^No.ɏĂFAT No. */
	SECTSIZE_T			dirsec;										/**< T[`̃fBNgZN^No. */
#if (MAX_DRIVE > 1)
	uint8_t				drive;										/**< T[`pX̃hCuNo. */
#endif
	uint8_t				clusfac;									/**< PNXӂ̃ZN^<br>
																		*  FAT32ȊOŃ[gfBNg̏ꍇGgɂ<br>
																		*  ZN^ƂĈ<br>
																		*  FAT32̏ꍇPNX^\ZN^Ɠlɂ<br>
																		*  T[`pXʒuړɐ؂ւKv<br>
																		*/
	uint8_t				seccluspos;									/**< T[`̃GgNX^̃ZN^ʒuItZbg */
	uint8_t				attrib;										/**< T[` */
	uint8_t				entlast;									/**< ŏIGg̃CfbNX */
	uint32_t			lastent;									/**< T[`ŏIGg̃CfbNX */
	uint32_t			entfree;									/**< T[`̋󂫃GgCfbNX */
}PATHSRCH;

/**********************************************************************/
/** t@CRg[ubN\́D
 *
 */
typedef	struct	inner_fcb_str {
#define		OPEN_DSK		0x80									/* I[vԂ */
#define		RENEWAL_FLG		0x40									/* t@CXVԂ
																	  *  f_closeɃGgXV邩ǂ̃tOŁA
																	  *  oepnVK쐬̏ꍇ<br>
																	  *  writest@CTCYAtȂǂ̃f[^ꍇ<br>
																	  *  TCYA^CX^vȂǂ̍XVT|[g<br>
																	*/
#define		FILEOPEN_FLG	0x20									/* t@C̃I[v */
#define		READONLY_FLG	0x04									/* t@C̃[hpI[v */
#define		WRITEONLY_FLG	0x08									/* t@C̃CgpI[v */
	int8_t				extStatusFlag;								/** eԃtO
																	  *   bit7  Ft@CI[vԃtO
																	  *           0FN[YԁA1FI[v
																	  *   bit6  Ft@CXVԃtO
																	  *           0FXVA1FXV
																	  *   bit5  Ft@CI[vԃtO
																	  *           0FfBNg쐬Ȃǂ̏
																	  *           1Ft@CI[v(f_open())
																	  *   bit3,2Ft@CI[vԃtO
																	  *           01F[hpI[v
																	  *           10FCgpI[v
																	  *           11F[h^CgI[v
																	  */
	uint8_t				extAttribute;								/**< t@C */
#if ( defined(__VFAT__) || defined(__VFAT_ASCII__) )
	int8_t				extShortFileName[(8+3+1)];					/**< V[gt@C(NULLt) */
	int8_t				extLongFileName[__FILE_PATH_LENGTH__+1];	/**< Ot@C(NULLt) */
#else
	int8_t				extFileName[8];								/**< DOS8.3t@C */
	int8_t				extExtent[3];								/**< DOS8.3gq */
	int8_t				dumy;										/**< NULLp̃_~[1oCg */
#endif
	uint32_t			extFileSize;								/**< t@CTCY */
	union	reserv {
		int8_t			extReserved2[8];
		CLUSFAC			clus;										/**< Ver 2.XX łFCBeɂ邽 */
	} uni_com ;
	uint32_t			extRandomRecNo;								/**< t@C|C^ */

	DPB					*pDPB;										/**< t@CɃANZXDPB
																		* ΏۂƂȂhCum肷ƃ|C^LƂȂ
																		*/
	PATHSRCH			fcbpath;									/**< pXT[`߂̍\ */
	BUFFINFO			*pBUF;										/**< pXT[`̃Gg[ƃobt@|C^ */
	SECTSIZE_T			entry_sector;								/**< fBNgGg̃ZN^ԍ */
	uint32_t			entry_offset;								/**< fBNgGg̃ZN^ItZbg */
} EXTFCB;

#if (MAX_DRIVE > 1)
/**********************************************************************/
/**
 * }Egۑp\.
 *  mount,partition_lbäpƃ[oufBXN̎̃f[^ۑpɎgp
 */
typedef struct {
	int8_t			usedflag;										/**< gpԃtO(ON;gpAOFF;gp) */
	int8_t			deviceno;										/**< foCXʔԍ */
	int8_t			letter;											/**< hCu^[ */
	DiskDriver		pDriver;										/**< hCo֐|C^ */
	EventDriver		pCallback;										/**< }CxgʒmpR[obN|C^ */
 #ifdef __FILE_OS_USED__
	SECTSIZE_T		bpb_start;										/**< hCůJnZN^ԍ */
 #endif
} MOUNT_T;
#endif

#ifdef __REMOVABLE_DISK__
/**********************************************************************/
/**
 * }CxgʒmpCxg\.
 */
typedef struct {
	int8_t			deviceno;										/**< foCXʔԍ */
	int8_t			inout;											/**< }(}G1 or G0) */
 #ifdef __FILE_OS_UNUSED__
  #if (MAX_DRIVE > 1)
	DiskDriver		pDriver;										/**< hCo֐|C^ */
	EventDriver		pCallback;										/**< }CxgʒmpR[obN|C^ */
  #endif
 #endif
	int32_t			driverno;										/**< hCoʔԍ */
} EVENT_INFO;
#endif

#ifdef __SEQUENCE_WRITE__
/**********************************************************************/
/** tH_ւ̘Aݗp\́D
 *
 */
typedef struct {
#define		SEQ_MODE_NORMAL			0								/**< ʏԂ */
#define		SEQ_MODE_START			1								/**< A݂JnƂ */
#define		SEQ_MODE_CONTINUE		2								/**< Ǎ݂pԂ */
	int8_t			seqflag;										/**< AݏԂtO
																	  *  0 ; ʏ퓮쒆
																	  *  1 ; A݊Jn
																	  *  2 ; Aݒ
																	*/
	EXTFCB			fcb;											/**< FCBf[^̃obNAbv */
	FATSIZE_T		cluster;										/**< A݂NX^ */
} SEQWRITE;
#endif

#ifdef __DYNAMIC_MEMORY__
/**********************************************************************/
/** I̊mۃTCY`
 *
 */
 #if (MAX_DRIVE > 1)
  #ifdef __FILE_OS_USED__
   #if (( defined(__VFAT__) || defined(__VFAT_ASCII__) ) && defined(__SEQUENCE_WRITE__))
    #define		FILE_MEMORY_SIZE		(MAX_DRIVE * __CACHE_COUNT__ * sizeof(BUFFINFO)) + 3	\
										 + (MAX_DRIVE * sizeof(DPB)) + 3						\
										 + (MAX_DRIVE * sizeof(MOUNT_T)) + 3					\
										 + sizeof(SEQWRITE) + 3									\
										 + ((__FILE_PATH_LENGTH__ + 1) * 2) + 3					\
										 + (__FILE_PATH_LENGTH__ + 1) + 3						\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
   #elif ( defined(__VFAT__) || defined(__VFAT_ASCII__) )
    #define		FILE_MEMORY_SIZE		(MAX_DRIVE * __CACHE_COUNT__ * sizeof(BUFFINFO)) + 3	\
										 + (MAX_DRIVE * sizeof(DPB)) + 3 						\
										 + (MAX_DRIVE * sizeof(MOUNT_T)) + 3					\
										 + ((__FILE_PATH_LENGTH__ + 1) * 2) + 3					\
										 + (__FILE_PATH_LENGTH__ + 1) + 3						\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
   #elif ( defined(__SEQUENCE_WRITE__) )
    #define		FILE_MEMORY_SIZE		(MAX_DRIVE * __CACHE_COUNT__ * sizeof(BUFFINFO)) + 3	\
										 + (MAX_DRIVE * sizeof(DPB)) + 3						\
										 + (MAX_DRIVE * sizeof(MOUNT_T)) + 3					\
										 + sizeof(SEQWRITE) + 3 								\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
   #else
    #define		FILE_MEMORY_SIZE		(MAX_DRIVE * __CACHE_COUNT__ * sizeof(BUFFINFO)) + 3	\
										 + (MAX_DRIVE * sizeof(DPB)) + 3						\
										 + (MAX_DRIVE * sizeof(MOUNT_T)) + 3					\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
   #endif
  #else
   #if (( defined(__VFAT__) || defined(__VFAT_ASCII__) ) && defined(__SEQUENCE_WRITE__))
    #define		FILE_MEMORY_SIZE		(MAX_DRIVE * __CACHE_COUNT__ * sizeof(BUFFINFO)) + 3	\
										 + (MAX_DRIVE * sizeof(DPB)) + 3						\
										 + (MAX_DRIVE * sizeof(MOUNT_T)) + 3					\
										 + (MAX_DRIVE * sizeof(EVENT_INFO)) + 3					\
										 + sizeof(SEQWRITE) + 3									\
										 + ((__FILE_PATH_LENGTH__ + 1) * 2) + 3					\
										 + (__FILE_PATH_LENGTH__ + 1) + 3						\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
   #elif ( defined(__VFAT__) || defined(__VFAT_ASCII__) )
    #define		FILE_MEMORY_SIZE		(MAX_DRIVE * __CACHE_COUNT__ * sizeof(BUFFINFO)) + 3	\
										 + (MAX_DRIVE * sizeof(DPB)) + 3 						\
										 + (MAX_DRIVE * sizeof(MOUNT_T)) + 3					\
										 + (MAX_DRIVE * sizeof(EVENT_INFO)) + 3					\
										 + ((__FILE_PATH_LENGTH__ + 1) * 2) + 3					\
										 + (__FILE_PATH_LENGTH__ + 1) + 3						\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
   #elif ( defined(__SEQUENCE_WRITE__) )
    #define		FILE_MEMORY_SIZE		(MAX_DRIVE * __CACHE_COUNT__ * sizeof(BUFFINFO)) + 3	\
										 + (MAX_DRIVE * sizeof(DPB)) + 3						\
										 + (MAX_DRIVE * sizeof(MOUNT_T)) + 3					\
										 + (MAX_DRIVE * sizeof(EVENT_INFO)) + 3					\
										 + sizeof(SEQWRITE) + 3									\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
   #else
    #define		FILE_MEMORY_SIZE		(MAX_DRIVE * __CACHE_COUNT__ * sizeof(BUFFINFO)) + 3	\
										 + (MAX_DRIVE * sizeof(DPB)) + 3						\
										 + (MAX_DRIVE * sizeof(MOUNT_T)) + 3					\
										 + (MAX_DRIVE * sizeof(EVENT_INFO)) + 3					\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
   #endif
  #endif
 #else
  #if (( defined(__VFAT__) || defined(__VFAT_ASCII__) ) && defined(__SEQUENCE_WRITE__))
   #define		FILE_MEMORY_SIZE		(__CACHE_COUNT__ * sizeof(BUFFINFO)) + 3				\
										 + sizeof(DPB) + 3										\
										 + sizeof(SEQWRITE) + 3									\
										 + ((__FILE_PATH_LENGTH__ + 1) * 2) + 3					\
										 + (__FILE_PATH_LENGTH__ + 1) + 3						\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
  #elif ( defined(__VFAT__) || defined(__VFAT_ASCII__) )
   #define		FILE_MEMORY_SIZE		(__CACHE_COUNT__ * sizeof(BUFFINFO)) + 3				\
										 + sizeof(DPB) + 3										\
										 + ((__FILE_PATH_LENGTH__ + 1) * 2) + 3					\
										 + (__FILE_PATH_LENGTH__ + 1) + 3						\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
  #elif ( defined(__SEQUENCE_WRITE__) )
   #define		FILE_MEMORY_SIZE		(__CACHE_COUNT__ * sizeof(BUFFINFO)) + 3				\
										 + sizeof(DPB) + 3										\
										 + sizeof(SEQWRITE) + 3									\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
  #else
   #define		FILE_MEMORY_SIZE		(__CACHE_COUNT__ * sizeof(BUFFINFO)) + 3				\
										 + sizeof(DPB) + 3										\
										 + (__FILE_COUNT__ * sizeof(EXTFCB)) + 3
  #endif
 #endif
#endif

/*------------------------------------------*/
/*				Jϐ					*/
/*------------------------------------------*/

/*------------------------------------------*/
/*				J֐					*/
/*------------------------------------------*/
#ifndef __DYNAMIC_MEMORY__
ISTATUS		ITF_FileSystemInit( void );
#else
ISTATUS		ITF_FileSystemInit( uint8_t * );
#endif
void		ITF_FileSystemEnd( void );
ISTATUS		disk_unmount( int8_t, int8_t );
ISTATUS		disk_mount( DiskDriver, int8_t, int8_t, EventDriver, int8_t );
#ifndef __READ_ONLY_API__
ISTATUS		f_mkdir( uint8_t * );
#endif
ISTATUS		f_open( EXTFCB **, uint8_t *, int32_t , int32_t );
ISTATUS		f_close( EXTFCB * );
ISTATUS		f_read ( EXTFCB *, void *, uint32_t, uint32_t * );
#ifndef __READ_ONLY_API__
ISTATUS		f_write( EXTFCB *, void *, uint32_t, uint32_t * );
#endif
#ifdef __HIGH_PERFORMANCE__
ISTATUS		f_flush( int8_t );
#endif
#ifndef __READ_ONLY_API__
ISTATUS		f_format( int8_t );
 #ifdef __UNLINK_API__
ISTATUS		f_unlink( uint8_t * );
 #endif
#endif
#ifdef __ASYNCHRONOUS_API__
ISTATUS		f_asynchronous( void );
#endif

#endif /* __ITFFILE_H__ */
